// Data Driven Gets

#define COMPILE(c) &("{||" + c + "}")

MEMVAR GetList

FUNCTION Gets2

FIELD ScrName, FldNum

  USE Screens NEW
  IF !File("Screens.ntx")
    INDEX ON Upper(ScrName) + Str(FldNum, 3) TO Screens
  ELSE
    SET INDEX TO Screens
  ENDIF
  USE Test NEW
  ReadScreen("TEST")

RETURN NIL

FUNCTION ReadScreen(cScrName)

FIELD ScrName, SayRow, SayCol, SayString, ;
      SayPict, SayColor IN Screens

FIELD GetRow,  GetCol, GetFld, GetPict, ;
      GetWhen, GetValid, GetColor IN Screens

  CLEAR SCREEN
  Screens -> (DbSeek(cScrName))
  DO WHILE cScrName == Trim(Upper(Screens -> ScrName))
    IF Empty(SayColor)
      @ SayRow, SayCol SAY Trim(SayString) PICTURE Trim(SayPict)
    ELSE
      @ SayRow, SayCol SAY Trim(SayString) PICTURE Trim(SayPict) ;
        COLOR Trim(SayColor)
    ENDIF

    IF !Empty(GetFld)
      @ GetRow, GetCol GET &GetFld PICTURE Trim(GetPict)

      IF !Empty(GetColor)
        Atail(GetList):colorSpec := GetColor
      ENDIF

      IF !Empty(GetWhen)
        Atail(GetList):preBlock := COMPILE(GetWhen)
      ENDIF

      IF !Empty(GetValid)
        Atail(GetList):postBlock := COMPILE(GetValid)
      ENDIF
    ENDIF

    Screens -> (DbSkip(1))
  ENDDO
  READ

RETURN NIL
